#ifndef FONT_H
#define FONT_H

#include <map>
#include <glm/vec2.hpp>

class PhongMaterial;

class Font
{
public:
    struct CharInfo
    {
        glm::vec2 pos;
        glm::vec2 dim;
        glm::vec2 offset;
        int xadvance;
    };
    Font();
    void setName(std::string name){m_name = name;}
    void addCharInfo(wchar_t character,CharInfo character_info){ m_charTable[character] = character_info; }
    void setNbChar(int nbchar){m_nbChar =nbchar;}
    void setLineHeight(int line_h){m_lineHeight = line_h;}
    void setBase(int base){m_base = base;}
    void setAntiAnliasing(bool antialiasing){m_antiAliasing = antialiasing;}
    void setScale(glm::vec2 scale){m_scale = scale;}
    void setMaterial(PhongMaterial* mat){m_mat = mat;}
private:
    std::string m_name;
    PhongMaterial* m_mat;
    std::map<wchar_t,CharInfo> m_charTable;
    glm::vec2 m_scale;
    bool m_antiAliasing;
    int m_nbChar, m_lineHeight,m_base;
};

#endif // FONT_H
